#ifndef INCLUDED_CALC_POSITIONNONE
#define INCLUDED_CALC_POSITIONNONE



#ifndef INCLUDED_STDDEFX
#include "stddefx.h"
#define INCLUDED_STDDEFX
#endif

// Library headers.

// PCRaster library headers.

// Module headers.
#ifndef INCLUDED_CALC_POSITION
#include "calc_position.h"
#define INCLUDED_CALC_POSITION
#endif



namespace calc {
  // PositionNone declarations.
}



namespace calc {



//! A non existing position: generated by system
/*!
   Error message will be prefixes by d_context, if set.
*/
class PositionNone : public Position
{

private:
  std::string            d_context;

  //! Assignment operator. NOT IMPLEMENTED.
  PositionNone&           operator=           (const PositionNone&);


public:

  //----------------------------------------------------------------------------
  // CREATORS
  //----------------------------------------------------------------------------

                   PositionNone               ();
                   PositionNone               (const std::string& context);

  // Copy constructor. DEFAULT
  //               PositionNone               (const PositionNone&);

  /* virtual */    ~PositionNone              () override;

  //----------------------------------------------------------------------------
  // MANIPULATORS
  //----------------------------------------------------------------------------

  //----------------------------------------------------------------------------
  // ACCESSORS
  //----------------------------------------------------------------------------
  void throwError(const std::string& msg) const override;

  PositionNone*    createClone() const override;

};



//------------------------------------------------------------------------------
// INLINE FUNCTIONS
//------------------------------------------------------------------------------



//------------------------------------------------------------------------------
// FREE OPERATORS
//------------------------------------------------------------------------------



//------------------------------------------------------------------------------
// FREE FUNCTIONS
//------------------------------------------------------------------------------



} // namespace calc

#endif
