import pcraster as pcr
from performance.timer_case.operation import Operation, Argument


operation_tuples = [
    ("abs", [pcr.VALUESCALE.Scalar]),
    # ("accucapacityflux", []),
    # ("accucapacitystate", []),
    # ("accuflux", []),
    # ("accufractionflux", []),
    # ("accufractionstate", []),
    # ("accustate", []),
    # ("accuthresholdflux", []),
    # ("accuthresholdstate", []),
    # ("accutraveltimeflux", []),
    # ("accutraveltimefractionflux", []),
    # ("accutraveltimefractionremoved", []),
    # ("accutraveltimefractionstate", []),
    # ("accutraveltimestate", []),
    # ("accutriggerflux", []),
    # ("accutriggerstate", []),
    ("acos", [pcr.VALUESCALE.Scalar]),
    # ("areaarea", []),
    # ("areaaverage", []),
    # ("areadiversity", []),
    # ("areamajority", []),
    # ("areamaximum", []),
    # ("areaminimum", []),
    # ("areanormal", []),
    # ("areaorder", []),
    # ("areatotal", []),
    # ("areauniform", []),
    # ("argorder", []),
    # ("argorderaddarealimited", []),
    # ("argorderarealimited", []),
    # ("argorderwithid", []),
    # ("argorderwithidaddarealimited", []),
    # ("argorderwithidarealimited", []),
    ("asin", [pcr.VALUESCALE.Scalar]),
    # ("aspect", []),
    ("atan", [pcr.VALUESCALE.Scalar]),
    # ("boolean", [pcr.VALUESCALE.Scalar]),
    # ("brenner", []),
    # ("catchment", []),
    # ("catchmenttotal", []),
    # ("cellarea", []),
    # ("celllength", []),
    # ("cellvalue", []),
    # ("clone", []),
    # ("clump", []),
    ("cos", [pcr.VALUESCALE.Scalar]),
    # ("cover", []),
    # ("defined", []),
    # ("diffuseflux", []),
    # ("diffusestate", []),
    # ("directional", []),
    # ("distributesimplegauss", []),
    # ("diver", []),
    # ("divergence", []),
    # ("downstream", []),
    # ("downstreamdist", []),
    # ("drain", []),
    # ("dynamicwaveh", []),
    # ("dynamicwaveq", []),
    # ("dynwaveflux", []),
    # ("dynwavestate", []),
    # ("ellipseaverage", []),
    ("exp", [pcr.VALUESCALE.Scalar]),
    # ("extentofview", []),
    # ("fac", []),
    # ("gradx", []),
    # ("grady", []),
    # ("horizontan", []),
    # ("ibngauss", []),
    ("ifthen", [pcr.VALUESCALE.Boolean, pcr.VALUESCALE.Scalar]),
    ("ifthenelse", [pcr.VALUESCALE.Boolean, pcr.VALUESCALE.Scalar,
        pcr.VALUESCALE.Scalar]),
    # ("index", []),
    # ("indexboolean", []),
    # ("indexdirectional", []),
    # ("indexldd", []),
    # ("indexnominal", []),
    # ("indexordinal", []),
    # ("indexscalar", []),
    # ("indextable", []),
    # ("influencesimplegauss", []),
    # ("initialise", []),
    # ("inversedistance", []),
    # ("kinematic", []),
    # ("kinwaveflux", []),
    # ("kinwavestate", []),
    # ("laplacian", []),
    # ("lax", []),
    # ("ldd", []),
    # ("lddcreate", []),
    # ("lddcreatedem", []),
    # ("lddcreatend", []),
    # ("lddcreatenddem", []),
    # ("ldddist", []),
    # ("lddmask", []),
    # ("lddrepair", []),
    # ("ln", []),
    # ("log10", []),
    # ("lookupboolean", []),
    # ("lookupdirectional", []),
    # ("lookupldd", []),
    # ("lookuplinear", []),
    # ("lookupmapstack", []),
    # ("lookupnominal", []),
    # ("lookupordinal", []),
    # ("lookuppotential", []),
    # ("lookupscalar", []),
    # ("lookupstate", []),
    # ("mapand", []),
    # ("maparea", []),
    # ("mapmaximum", []),
    # ("mapminimum", []),
    # ("mapnormal", []),
    # ("mapor", []),
    # ("maptotal", []),
    # ("mapuniform", []),
    # ("markwhilesumge", []),
    # ("markwhilesumle", []),
    ("max", [pcr.VALUESCALE.Scalar, pcr.VALUESCALE.Scalar]),
    ("min", [pcr.VALUESCALE.Scalar, pcr.VALUESCALE.Scalar]),
    # ("move", []),
    # ("muskingum", []),
    # ("nodirection", []),
    # ("nominal", []),
    # ("normal", []),
    # ("numpy", []),
    # ("numpy2pcr", []),
    # ("order", []),
    # ("ordinal", []),
    # ("pcr2numpy", []),
    # ("pcrand", []),
    # ("pcraster", []),
    ("pcrbadd", [pcr.VALUESCALE.Scalar, pcr.VALUESCALE.Scalar]),
    ("pcrbmin", [pcr.VALUESCALE.Scalar, pcr.VALUESCALE.Scalar]),
    # ("pcreq", []),
    # ("pcrfdiv", []),
    # ("pcrge", []),
    # ("pcrgt", []),
    # ("pcridiv", []),
    # ("pcrle", []),
    # ("pcrlt", []),
    # ("pcrmod", []),
    ("pcrmul", [pcr.VALUESCALE.Scalar, pcr.VALUESCALE.Scalar]),
    # ("pcrne", []),
    # ("pcrnot", []),
    # ("pcror", []),
    ("pcrpow", [pcr.VALUESCALE.Scalar, pcr.VALUESCALE.Scalar]),
    # ("pcruadd", []),
    # ("pcrumin", []),
    # ("pcrxor", []),
    # ("pit", []),
    # ("plancurv", []),
    # ("pred", []),
    # ("profcurv", []),
    # ("riksfraction", []),
    # ("rounddown", []),
    # ("roundoff", []),
    # ("roundup", []),
    # ("scalar", []),
    # ("shift", []),
    # ("shift0", []),
    # ("sin", []),
    ("slope", [pcr.VALUESCALE.Scalar]),
    # ("slopelength", []),
    # ("spatial", []),
    # ("spread", []),
    # ("spreadldd", []),
    # ("spreadlddzone", []),
    # ("spreadmax", []),
    # ("spreadmaxzone", []),
    # ("spreadzone", []),
    # ("sqr", []),
    ("sqrt", [pcr.VALUESCALE.Scalar]),
    # ("squarefraction", []),
    # ("streamorder", []),
    # ("subcatchment", []),
    # ("subprocess", []),
    # ("succ", []),
    # ("tan", []),
    # ("timeinput", []),
    # ("timeinputboolean", []),
    # ("timeinputdirectional", []),
    # ("timeinputldd", []),
    # ("timeinputmodulo", []),
    # ("timeinputnominal", []),
    # ("timeinputordinal", []),
    # ("timeinputscalar", []),
    # ("timeinputsparse", []),
    # ("timeoutput", []),
    # ("timeslice", []),
    # ("transient", []),
    # ("uniform", []),
    # ("uniqueid", []),
    # ("upstream", []),
    # ("view", []),
    ("window4total", [pcr.VALUESCALE.Scalar]),
    # ("windowaverage", []),
    # ("windowdiversity", []),
    # ("windowhighpass", []),
    # ("windowmajority", []),
    # ("windowmaximum", []),
    # ("windowminimum", []),
    # ("windowtotal", []),
    # ("xcoordinate", []),
    # ("ycoordinate", [])
]


operations = [Operation(tpl[0],
    [Argument(value_scale) for value_scale in tpl[1]])
    for tpl in operation_tuples]
